Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 684830 - dev-util/apitrace-8.0 should not link with non-native app-arch/brotli
Summary: dev-util/apitrace-8.0 should not link with non-native app-arch/brotli
Status: IN_PROGRESS
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: No maintainer - Look at https://wiki.gentoo.org/wiki/Project:Proxy_Maintainers if you want to take care of it
URL:
Whiteboard:
Keywords: PATCH
Depends on:
Blocks:
 
Reported: 2019-04-30 20:19 UTC by Alexander Tsoy
Modified: 2019-05-09 12:00 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
apitrace-8.0:20190430-191820.log.gz (apitrace.log.gz,8.81 KB, application/gzip)
2019-04-30 20:19 UTC, Alexander Tsoy
Details
apitrace-8.0-brotli-unbundle.patch (apitrace-8.0-brotli-unbundle.patch,4.68 KB, text/plain)
2019-04-30 21:15 UTC, Alexander Tsoy
Details
apitrace-8.0-glxtrace-only.patch (apitrace-8.0-glxtrace-only.patch,3.23 KB, text/plain)
2019-05-09 11:34 UTC, Alexander Tsoy
Details
apitrace-8.0.ebuild-v1.patch (apitrace-8.0.ebuild-v1.patch,1.36 KB, text/plain)
2019-05-09 11:53 UTC, Alexander Tsoy
Details
apitrace-8.0.ebuild-v2.patch (apitrace-8.0.ebuild-v2.patch,2.24 KB, text/plain)
2019-05-09 11:55 UTC, Alexander Tsoy
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Alexander Tsoy 2019-04-30 20:19:11 UTC
Created attachment 574876 [details]
apitrace-8.0:20190430-191820.log.gz

dev-util/apitrace-8.0[abi_x86_32] fails to build with app-arch/brotli[-abi_x86_32]:

/usr/lib/gcc/x86_64-pc-linux-gnu/8.3.0/../../../../x86_64-pc-
linux-gnu/bin/ld: cannot find -lbrotlidec
/usr/lib/gcc/x86_64-pc-linux-gnu/8.3.0/../../../../x86_64-pc-
linux-gnu/bin/ld: cannot find -lbrotlienc

And I don't think multilib dependency is needed here:

$ cat /var/db/pkg/dev-util/apitrace-8.0/REQUIRES
x86_32: ld-linux.so.2 libc.so.6 libdl.so.2 x86_64: ld-linux-x86-64.so.2 libX11.so.6 libbrotlidec.so.1 libbrotlienc.so.1 libc.so.6 libdl.so.2 libgcc_s.so.1 libm.so.6 libpng16.so.16 libprocps.so.7 libpthread.so.0 librt.so.1 libstdc++.so.6 libz.so.1

$ ldd /usr/lib/apitrace/wrappers/*
/usr/lib/apitrace/wrappers/egltrace.so:
        linux-gate.so.1 (0xf7f21000)
        libdl.so.2 => /lib/libdl.so.2 (0xf7ac1000)
        libc.so.6 => /lib/libc.so.6 (0xf78d5000)
        /lib/ld-linux.so.2 (0xf7f22000)
/usr/lib/apitrace/wrappers/glxtrace.so:
        linux-gate.so.1 (0xf7f80000)
        libdl.so.2 => /lib/libdl.so.2 (0xf7b24000)
        libc.so.6 => /lib/libc.so.6 (0xf7938000)
        /lib/ld-linux.so.2 (0xf7f81000)


$ emerge --info apitrace
Portage 2.3.62 (python 3.6.5-final-0, default/linux/amd64/17.1/hardened, gcc-8.3.0, glibc-2.28-r6, 4.19.36-gentoo x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-4.19.36-gentoo-x86_64-Intel-R-_Core-TM-_i5_CPU_660_@_3.33GHz-with-gentoo-2.6
KiB Mem:     8020884 total,   1529104 free
KiB Swap:    8388604 total,   8011004 free
Timestamp of repository gentoo: Tue, 30 Apr 2019 17:30:01 +0000
Head commit of repository gentoo: 816567bbc89b9b0752db03cb586b7d2865f69466
Head commit of repository puleglot: 36a7bcf0b5f9414c38a868a933043c5913f00f91

sh dash 0.5.9.1-r3
ld GNU ld (Gentoo 2.31.1 p5) 2.31.1
distcc 3.3.2 x86_64-pc-linux-gnu [disabled]
app-shells/bash:          4.4_p23-r1::gentoo
dev-java/java-config:     2.2.0-r4::gentoo
dev-lang/perl:            5.26.2::gentoo
dev-lang/python:          2.7.15::gentoo, 3.6.5::gentoo
dev-util/cmake:           3.9.6::gentoo
dev-util/pkgconfig:       0.29.2::gentoo
sys-apps/baselayout:      2.6-r1::gentoo
sys-apps/sandbox:         2.13::gentoo
sys-devel/autoconf:       2.13-r1::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.11.6-r3::gentoo, 1.13.4-r2::gentoo, 1.16.1-r1::gentoo
sys-devel/binutils:       2.31.1-r4::gentoo
sys-devel/gcc:            8.3.0-r1::gentoo
sys-devel/gcc-config:     2.0::gentoo
sys-devel/libtool:        2.4.6-r3::gentoo
sys-devel/make:           4.2.1-r4::gentoo
sys-kernel/linux-headers: 4.14-r1::gentoo (virtual/os-headers)
sys-libs/glibc:           2.28-r6::gentoo
Repositories:

gentoo
    location: /var/db/repos/gentoo
    sync-type: rsync
    sync-uri: rsync://10.8.10.1/gentoo-portage
    priority: -1000
    sync-rsync-verify-jobs: 2
    sync-rsync-extra-opts: 
    sync-rsync-verify-metamanifest: yes
    sync-rsync-verify-max-age: 24

crossdev
    location: /var/db/repos/crossdev
    masters: gentoo
    priority: 100

puleglot
    location: /var/db/repos/puleglot
    sync-type: git
    sync-uri: https://puleglot.ru/git/gentoo/puleglot-overlay.git
    masters: gentoo
    priority: 900

local
    location: /usr/local/portage
    masters: gentoo
    priority: 1000

ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -march=core2 -mtune=core2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/easy-rsa /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-O2 -march=core2 -mtune=core2 -pipe"
DISTDIR="/var/cache/distfiles"
EMERGE_DEFAULT_OPTS="--dynamic-deps=n --with-bdeps=y --binpkg-respect-use=y --ask-enter-invalid"
ENV_UNSET="DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs buildpkg cgroup compress-build-logs config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict network-sandbox news parallel-fetch pid-sandbox preserve-libs protect-owned sandbox sfperms split-log strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://mirror.yandex.ru/gentoo-distfiles/ http://distfiles.gentoo.org/"
LANG="ru_RU.utf8"
LC_ALL="ru_RU.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j2"
PKGDIR="/var/cache/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="X aac acl acpi aio alsa amd64 amr ape asyncns avahi bash-completion berkdb bluetooth bluray branding bzip2 cairo caps cdda cddb cdparanoia cdr cli colord crypt cryptsetup cups cxx dbus dconf device-mapper djvu dri dts dvd dvdr eds egl evo examples exif faac faad ffmpeg flac fontconfig fuse gdbm gif gnome gnome-keyring gnome-online-accounts gpm gstreamer gtk gtk3 hardened iconv icu idn ieee1394 introspection ipv6 jpeg jpeg2k lcms libass libnotify libsecret libtirpc lz4 lzma mac maildir mms mp3 mp4 multilib musepack musicbrainz nautilus ncurses networkmanager nls nptl ogg opengl openmp opus pam pcre perl pie png policykit postscript pulseaudio python raw readline samba sasl seccomp speex spell ssl ssp startup-notification svg systemd theora tiff tls truetype udev unicode upnp-av urandom usb vaapi vdpau vim-syntax vorbis vpx wavpack webp x264 xattr xfs xtpax xv xvid xz zeroconf zlib zstd" ABI_X86="64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" APACHE2_MPMS="prefork" CALLIGRA_FEATURES="karbon sheets words" CAMERAS="*" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="mmx mmxext sse sse2 sse3 ssse3 sse4_1" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="pc" INPUT_DEVICES="evdev libinput" KERNEL="linux" L10N="en ru" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" NETBEANS_MODULES="apisupport cnd groovy gsf harness ide identity j2ee java mobility nb php profiler soa visualweb webcommon websvccommon xml" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-6 php7-1" POSTGRES_TARGETS="postgres9_5 postgres10" PYTHON_SINGLE_TARGET="python3_6" PYTHON_TARGETS="python2_7 python3_6" QEMU_SOFTMMU_TARGETS="aarch64 arm i386 mips mips64 mips64el mipsel x86_64" QEMU_USER_TARGETS="aarch64 arm" RUBY_TARGETS="ruby24" USERLAND="GNU" VIDEO_CARDS="amdgpu radeon radeonsi intel vesa mga" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LINGUAS, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS

=================================================================
                        Package Settings
=================================================================

dev-util/apitrace-8.0::gentoo was built with the following:
USE="cli egl -qt5 -system-snappy" ABI_X86="32 (64) (-x32)" PYTHON_TARGETS="python2_7"
Comment 1 Alexander Tsoy 2019-04-30 21:15:04 UTC
Created attachment 574878 [details]
apitrace-8.0-brotli-unbundle.patch

Updated apitrace-8.0-brotli-unbundle.patch that fixes this issue for me.

Probably multilib zlib dependency is also unnecessary and can be removed with trivial build system change.
Comment 2 Alexander Tsoy 2019-04-30 21:25:42 UTC
(In reply to Alexander Tsoy from comment #1)
> Created attachment 574878 [details]
> apitrace-8.0-brotli-unbundle.patch
Or maybe it would be better to add condition to apitrace-8.0-glxtrace-only.patch and then rebase apitrace-8.0-brotli-unbundle.patch.
Comment 3 Andreas Sturmlechner gentoo-dev 2019-05-01 14:21:22 UTC
Right, the brotli-unbundle patch needs to stay upstreamable which it is not with glxtrace-only artifacts.
Comment 4 Matt Turner gentoo-dev 2019-05-09 00:02:13 UTC
*** Bug 684964 has been marked as a duplicate of this bug. ***
Comment 5 Alexander Tsoy 2019-05-09 11:34:47 UTC
Created attachment 575592 [details]
apitrace-8.0-glxtrace-only.patch

Updated apitrace-8.0-glxtrace-only.patch
Comment 6 Alexander Tsoy 2019-05-09 11:53:54 UTC
Created attachment 575594 [details]
apitrace-8.0.ebuild-v1.patch

This patch just disables unnecessary multilib dependencies.
Comment 7 Alexander Tsoy 2019-05-09 11:55:41 UTC
Created attachment 575596 [details]
apitrace-8.0.ebuild-v2.patch

This patch allows to build apitrace cli for all ABIs.
Comment 8 Alexander Tsoy 2019-05-09 12:00:45 UTC
Note that I didn't tested gui dependencies.

Uploaded patches also changes two things:
- libGL symlinks should be created for all ABIs;
- python scripts already installed with USE=cli. IMHO no need to copy them in ebuild.